-- Stillman Lecture 1, AWS 2006, Tucson, March 11-15.
------------------------------
-- Example 1: twisted cubic --
------------------------------
S = QQ[a..d];
I = ideal(b^2-a*c, b*c-a*d, c^2-b*d)
N = sheaf prune Hom(I,S^1/I)
HH^0(N)
HH^1(N)

------------------------------
-- Example 2: lex point ------
------------------------------
S = QQ[a..d];
I = ideal(a, b^4, b^3*c)
R = S/I
IR = prune((module I) ** R)
N = sheaf prune Hom(IR,R)
HH^0(N)
HH^1(N)
Ext^1(sheaf IR, sheaf R)

--------------------------------
-- Example 3: on intersection --
--------------------------------
S = QQ[symbol a..symbol d];
I = ideal(a^2, a*b, a*c, b^3)
R = S/I
IR = prune((module I) ** R)
N = sheaf prune Hom(IR,R)
HH^0(N)
HH^1(N)
Ext^1(sheaf IR, sheaf R)

----------------------------
-- Example : normal sheaf --
----------------------------
S = QQ[a..d];
I = intersect(ideal(a,b),ideal(b,c),ideal(c,d))
phi = presentation module I
R = S/I;
phi ** R
transpose(phi ** R)
N = kernel transpose(phi ** R)
N = prune N

res N -- partial resolution over R
-- Let's write a presentation of N over S.
f = presentation N
lift(f,S)
coker oo
oo ** S^1/I
NS = prune oo
C = res NS
betti C
C.dd

HH^0(sheaf N)

